org.bouncycastle.crypto.engines

## Class ChaCha7539Engine

- java.lang.Object
- - org.bouncycastle.crypto.engines.Salsa20Engine
  - - org.bouncycastle.crypto.engines.ChaCha7539Engine

- All Implemented Interfaces:
    SkippingCipher, SkippingStreamCipher, StreamCipher
  Direct Known Subclasses:
    XChaCha20Engine

      public class ChaCha7539Engine
      extends Salsa20Engine

  Implementation of Daniel J. Bernstein's ChaCha stream cipher.

- - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.crypto.engines.Salsa20Engine

      `DEFAULT_ROUNDS, engineState, rounds, sigma, tau, x`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChaCha7539Engine()` Creates a 20 rounds ChaCha engine.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `advanceCounter()`
    `protected void` | `advanceCounter(long diff)`
    `protected void` | `generateKeyStream(byte[] output)`
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the cipher implements.
    `protected long` | `getCounter()`
    `protected int` | `getNonceSize()`
    `protected void` | `resetCounter()`
    `protected void` | `retreatCounter()`
    `protected void` | `retreatCounter(long diff)`
    `protected void` | `setKey(byte[] keyBytes, byte[] ivBytes)`

    - ### Methods inherited from class org.bouncycastle.crypto.engines.Salsa20Engine

      `getPosition, init, packTauOrSigma, processBytes, reset, returnByte, salsaCore, seekTo, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ChaCha7539Engine

          public ChaCha7539Engine()

      Creates a 20 rounds ChaCha engine.

  - ### Method Detail

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `StreamCipher`
      Return the name of the algorithm the cipher implements.
      Specified by:
        `getAlgorithmName` in interface `StreamCipher`
      Overrides:
        `getAlgorithmName` in class `Salsa20Engine`
      Returns:
        the name of the algorithm the cipher implements.

    - #### getNonceSize

          protected int getNonceSize()

      Overrides:
        `getNonceSize` in class `Salsa20Engine`

    - #### advanceCounter

          protected void advanceCounter(long diff)

      Overrides:
        `advanceCounter` in class `Salsa20Engine`

    - #### advanceCounter

          protected void advanceCounter()

      Overrides:
        `advanceCounter` in class `Salsa20Engine`

    - #### retreatCounter

          protected void retreatCounter(long diff)

      Overrides:
        `retreatCounter` in class `Salsa20Engine`

    - #### retreatCounter

          protected void retreatCounter()

      Overrides:
        `retreatCounter` in class `Salsa20Engine`

    - #### getCounter

          protected long getCounter()

      Overrides:
        `getCounter` in class `Salsa20Engine`

    - #### resetCounter

          protected void resetCounter()

      Overrides:
        `resetCounter` in class `Salsa20Engine`

    - #### setKey

          protected void setKey(byte[] keyBytes,
                                byte[] ivBytes)

      Overrides:
        `setKey` in class `Salsa20Engine`

    - #### generateKeyStream

          protected void generateKeyStream(byte[] output)

      Overrides:
        `generateKeyStream` in class `Salsa20Engine`